import json

with open('minecraft_data/registries.json') as f:
    MOBS = json.load(f)['minecraft:entity_type']['entries']

EVIL = [
    'blaze',
    'cave_spider',
    'creeper',
    'drowned',
    'elder_guardian',
    'ender_dragon',
    'enderman',
    'endermite',
    'evoker',
    'ghast',
    'giant',
    'guardian',
    'hoglin',
    'husk',
    'illusioner',
    'magma_cube',
    'phantom',
    'piglin',
    'piglin_brute',
    'pillager',
    'ravager',
    'shulker',
    'silverfish',
    'skeleton',
    'skeleton_horse',
    'slime',
    'spider',
    'stray',
    'vex',
    'vindicator',
    'witch',
    'wither',
    'zoglin',
    'zombie',
    'zombie_villager',
]

EVIL_IDS = set()
for mob_name in EVIL:
    EVIL_IDS.add(MOBS['minecraft:'+mob_name]['protocol_id'])

MOB_NAMES = {}
for mob_name, mob in MOBS.items():
    MOB_NAMES[MOBS[mob_name]['protocol_id']] = mob_name.replace('minecraft:', '')
